 /*------------------------------------------------------------------------
    File        : BuildShare
    Purpose     : Scan code base and build shared variable referesnce
    Syntax      : 
    Description : 
    Author(s)   : Thomas Mercer-Hursh
    Created     : Tue Apr 21 14:51:48 CDT 2015
    Notes       : 
  ----------------------------------------------------------------------*/

using Progress.Lang.*.
using com.cintegrity.ABL2DB.BuildDirectoryTree.
using com.cintegrity.ABL2DB.BuildSharedOne.

block-level on error undo, throw.

class com.cintegrity.ABL2DB.BuildShared inherits BuildDirectoryTree: 
  define public property chLogicalDataBaseList as character no-undo get. set.
  define public property chAliasList as character no-undo get. set.
  define public property chSchemaDirectory as character no-undo get. set.
  define public property inTotalFiles as integer no-undo get. private set.
  define public property inTotalCompiled as integer no-undo get. private set.
  define public property inTotalShared as integer no-undo get. private set.
  define public property inTotalExceptions as integer no-undo get. private set.
  
  define private variable obBuildSharedOne as class BuildSharedOne no-undo.

 	constructor public BuildShared ( 
      ipchSourceDirectoryectory as character
      ):  
    super ( ipchSourceDirectoryectory ).
	end constructor.

	destructor public BuildShared ( ):
	  if valid-object(obReport) 
    then obReport:WriteMessage ( substitute("End of BuildShared with &1 shared variables in &2 compile units of &3 total files", inTotalShared, inTotalCompiled, inTotalFiles ) ).
    log-manager:write-message ( substitute( "End BuildShared with &1 exceptions", inTotalExceptions )).
	end destructor.

  method public override void Initialize():
    super:Initialize().

    log-manager:write-message ("Start BuildShared").
    obReport:WriteMessage ( substitute("Exception list for object build of &1", chSourceDirectoryList ) ).

  end method.
  
  method public override void Process():
    /* set chValidExtensions and/or chExcludeExtensions and/or lgExcludeNoExtension as necessary in Driver */
    super:Process().
    
    ScanAll ().
    
  end method.
  
  method private void ScanAll():
    define buffer bfContents for ttContents.
    
    for each bfContents where not bfContents.lgIsProcessed and not lgIsDir:
      obBuildSharedOne = new BuildSharedOne( obReport ).
      obBuildSharedOne:chLogicalDataBaseList = chLogicalDataBaseList.
      obBuildSharedOne:chAliasList = chAliasList.
      obBuildSharedOne:chSchemaDirectory = chSchemaDirectory.
      obBuildSharedOne:Initialize().
      obBuildSharedOne:ProcessOne( 
          bfContents.chName,
          bfContents.chPackage,
          bfContents.chSourceDirectory,
          bfContents.chFullPath,
          bfContents.chExtension
          ).
      inTotalFiles = inTotalFiles + obBuildSharedOne:inTotalFiles.
      inTotalCompiled = inTotalCompiled + obBuildSharedOne:inTotalCompiled.
      inTotalExceptions = inTotalExceptions + obBuildSharedOne:inTotalExceptions.
      inTotalShared = inTotalShared + obBuildSharedOne:inTotalShared.
      bfContents.lgIsProcessed = true.
      
      delete object obBuildSharedOne.
    end. /* for each */

  end method.

end class.