/*------------------------------------------------------------------------
    File        : SchemaUtilities
    Purpose     : 
    Syntax      : 
    Description : Utilities for manipulating schema entities in the context of ABL2DB
    Author(s)   : Thomas Mercer-Hursh
    Created     : Sat Aug 16 13:33:07 CDT 2014
    Notes       : These methods are intended to be customized for site specific use
  ----------------------------------------------------------------------*/

using Progress.Lang.*.

routine-level on error undo, throw.

class com.cintegrity.ABL2DB.SchemaUtilities: 
  define public property chDefaultMetaDB as character no-undo initial "Analysis" get. set.
		
	constructor public SchemaUtilities (  ):
		super ().
		
	end constructor.

	destructor public SchemaUtilities ( ):

	end destructor.

                         /* Apply standard DB name for Metaschema table */
  method public character MassageMetaDBName ( 
      ipchDatabaseName as character
      ): 
    define variable mchDatabaseName as character.
    if ipchDatabaseName = chDefaultMetaDB
    then mchDatabaseName = "DICTDB".
    else mchDatabaseName = ipchDatabaseName.
    /* Other options include always DICTDB or using first attached during compilation */
    return mchDatabaseName.
  end method.
                          /* Find table name from buffer name; customize to code base as needed */
  method public character FindTableForBuffer (   
      ipchDBID as character,
      ipchBufferName as character
      ):
    define buffer bfDB_Table for DB_Table.
    
    do for bfDB_Table:
      find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = ipchBufferName no-error.
      if not available (bfDB_Table)
      then do:
        if ipchBufferName begins "ibf_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,5) no-error.
        else if ipchBufferName begins "lbf_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,5) no-error.
        else if ipchBufferName begins "pbu_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,5) no-error.
        else if ipchBufferName begins "lbu_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,5) no-error.
        else if ipchBufferName begins "bf_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,4) no-error.
        else if ipchBufferName begins "b1_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,4) no-error.
        else if ipchBufferName begins "b2_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,4) no-error.
        else if ipchBufferName begins "b3_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,4) no-error.
        else if ipchBufferName begins "b4_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,4) no-error.
        else if ipchBufferName begins "bf"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,3) no-error.        
        else if ipchBufferName begins "b_"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,3) no-error. 
        else if ipchBufferName begins "b"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,2) no-error.
        else if ipchBufferName begins "w"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,2) no-error.  
        else if ipchBufferName matches "*-buff"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,1,length(ipchBufferName) - 5) no-error.    
        else if ipchBufferName matches "*-buf"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,1,length(ipchBufferName) - 4) no-error.    
        else if ipchBufferName matches "*###"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,1,length(ipchBufferName) - 3) no-error.    
        else if ipchBufferName matches "*##"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,1,length(ipchBufferName) - 2) no-error.    
        else if ipchBufferName matches "*#"
        then find bfDB_Table no-lock where bfDB_Table.chDBID = ipchDBID and bfDB_Table.chTableName = substring(ipchBufferName,1,length(ipchBufferName) - 1) no-error.    
        if not available (bfDB_Table)
        then undo, throw new Progress.Lang.AppError ( substitute("Table not found for buffer &1", ipchBufferName) ).
        else return bfDB_Table.chID.
      end.       
      else return bfDB_Table.chID.
    end.
    return "".
  end.

end class.