/*------------------------------------------------------------------------
    Table       : DocSchemaFromDF
    Purpose     : 
    Syntax      : 
    Description : Dump proparse.schema for use by Proparse from DF files
    Author(s)   : Administrator
    Created     : Sat Mar 22 10:43:17 CDT 2014
    Notes       : 
      
               NEEDS WORK!   Not a complete function     
 
  ----------------------------------------------------------------------*/

using Progress.Lang.*.

routine-level on error undo, throw.

class com.cintegrity.Proparse.DocSchemaFromDF: 
  define public property chReportDestination as character no-undo get. set.
  define public property inTableTotal as integer no-undo get. private set.
  define public property inColumnTotal as integer no-undo get. private set.
  define public property inIndexTotal as integer no-undo get. private set.
  define public property inTotalExceptions as integer no-undo get. private set.
  
  define private variable chDFDirectory as character no-undo.
  define private variable chDFFileList as character no-undo.
  define private variable chDFFile as character no-undo.
  define private variable chCurrentDBID as character no-undo.
  define private variable chCurrentDBName as character no-undo.
  define private variable chProparseSchemaFile as character no-undo.
  define private variable chCurrentLine as character no-undo.
  define private variable inLineNo as integer no-undo.
  
  define stream stSchemaDF.
  define stream stPPSchema.
  		
	constructor public DocSchemaFromDF ( 
	    ipchDFDirectory as character,
	    ipchDFFileList as character
	    ):
		assign
		    chDFDirectory = ipchDFDirectory
        chDFFileList = ipchDFFileList
        .
	end constructor.

	destructor public DocSchemaFromDF ( ):
    input stream stSchemaDF close.  
	end destructor.
/*	
	method public void Initialize():
	  define variable minWhich as integer no-undo.
  
    do minWhich = 1 to num-entries( chDFFileList ):
      chDFFile = obPathUtilities:FullPathFromComponents( chDFDirectory, entry( minWhich, chDFFileList ) + ".df").
  	  file-info:file-name = chDFFile.
      if file-info:full-pathname = ? 
          or not file-info:file-type begins "F" 
          or not file-info:file-type matches "*R*"
      then do:
        log-manager:write-message (substitute("BuildSchemaDF ERROR: Input Schema DF File (&1) not found", chDFFile )).
        undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Unable to initialize." ).  
      end.
    end.
    obReport = new FlyWeightLogger().
    obReport:chLogDestination = chReportDestination. 
    obReport:Initialize( ).
    obReport:WriteMessage ( "Begin List of BuildSchemaDF exceptions" ).
    chProparseSchemaFile = obPathUtilities:FullPathFromComponents( chDFDirectory, "proparse":u, "schema":U).
  end method.

  method public void Process():
    define variable minWhich as integer no-undo.
    define variable mchCurrentDB as character no-undo.
    define variable mchFirstToken as character no-undo.
    define buffer bfDB_DB for DB_DB.
    
    do minWhich = 1 to num-entries( chDFFileList ):
      mchCurrentDB = entry( minWhich, chDFFileList ).
      chDFFile = obPathUtilities:FullPathFromComponents( chDFDirectory, mchCurrentDB + ".df").
      do for bfDB_DB transaction:
        create bfDB_DB.
        assign 
            bfDB_DB.chID = guid
            chCurrentDBID = bfDB_DB.chID
            bfDB_DB.chDB_Name = mchCurrentDB
            chCurrentDBName = mchCurrentDB
            .
      end.

      input stream stSchemaDF from value(chDFFile) no-echo.
      output stream stPPSchema to value(chProparseSchemaFile) no-echo.
      put stream stPPSchema unformatted ":: ":U mchCurrentDB " ":U minWhich skip.
      
      OUTER-LOOP:
      repeat:
        import stream stSchemaDF unformatted chCurrentLine.
        inLineNo = inLineNo + 1.
        mchFirstToken = entry(1,chCurrentLine," ").
        case mchFirstToken:
          when "" then next OUTER-LOOP.
          when "ADD" then ProcessAdd().
          when "DROP" then ProcessDrop().
          when "." then leave OUTER-LOOP.
          otherwise do:
            obReport:WriteMessage ( substitute("BuildSchemaDF ERROR: Unexpected first token '(&1)' found at line &2 processing DB &3", mchFirstToken, inLineNo, chCurrentDBName )).
            inTotalExceptions = inTotalExceptions + 1.
          end.
        end case.
      end. /* repeat */
    end. /* do */
    output stream stPPSchema close.
    return. 
  end method.

  method private void ProcessAdd():
    define variable mchSecondToken as character no-undo.    
    
    mchSecondToken = entry(2,chCurrentLine," ").
    case mchSecondToken:
      when "TABLE" then ProcessTableAdd().
      when "FIELD" then ProcessColumnAdd().
      when "INDEX" then ProcessIndexAdd().
      when "SEQUENCE" then ProcessSequenceAdd().
      otherwise do:
        obReport:WriteMessage (substitute("BuildSchemaDF ERROR: Unexpected second token '&1' found at line &2 processing DB &3", mchSecondToken, inLineNo, chCurrentDBName )).
        inTotalExceptions = inTotalExceptions + 1.
      end.
    end case.      
  end method.
  
  method private void ProcessTableAdd():
    define variable mchCurrentTableID as character no-undo.
    define variable mchFirstToken as character no-undo.    
    define variable mchSecondToken as character no-undo.    
    define variable mchThirdToken as character no-undo.  
    
    define variable mchTableName as character no-undo.
    define variable mchTableArea as character no-undo.
    define variable mchTableDumpName as character no-undo. 
    define variable mchTableDescription as character no-undo.
    define variable mchLabel as character no-undo.
    define variable mchLabelSA as character no-undo.
    define variable mchValMsgSA as character no-undo.
    define variable minWhich as integer no-undo.    
    define variable mchMessage as character no-undo.
    define variable mlgFrozen as logical no-undo.
    define variable mlgHidden as logical no-undo.
    define variable mchForeignName as character no-undo.
    define variable mchCategory as character no-undo.
    define variable mchTableID as character no-undo.
        
    define buffer bfDB_Table for DB_Table. 
    define buffer bfDB_Column for DB_Column.
    define buffer bfDB_TableTrigger for DB_TableTrigger.
    
    assign
        inTableTotal = inTableTotal + 1
        mchThirdToken = entry(3,chCurrentLine," ")
        mchTableName = replace(mchThirdToken,'"',"")
        mchCurrentTableID = guid
        .  
    PROCESS-LOOP:
    repeat:
      import stream stSchemaDF unformatted chCurrentLine.
      chCurrentLine = trim(chCurrentLine).      
      inLineNo = inLineNo + 1.
      if chCurrentLine = "" or chCurrentLine = "." then leave PROCESS-LOOP.
      mchFirstToken = entry(1,chCurrentLine," ").
      if num-entries(chCurrentLine, " ") > 1
      then mchSecondToken = entry(2,chCurrentLine," ").
      else mchSecondToken = "".
      case mchFirstToken:
        when "AREA" then mchTableArea = replace(mchSecondToken,'"',"").
        when "CATEGORY" then mchCategory = mchSecondToken.
        when "DUMP-NAME" then mchTableDumpName = replace(mchSecondToken,'"',"").
        when "DESCRIPTION" then mchTableDescription = QuotedExp(chCurrentLine).
        when "FOREIGN-NAME" then mchForeignName = QuotedExp(chCurrentLine).
        when "FROZEN" then mlgFrozen = true.
        when "HIDDEN" then mlgHidden = true.
        when "LABEL" then mchLabel = QuotedExp(chCurrentLine).
        when "LABEL-SA" then mchLabelSA = QuotedExp(chCurrentLine).
        when "TABLE-TRIGGER"
        then do for bfDB_TableTrigger:
          create bfDB_TableTrigger.
          assign
              bfDB_TableTrigger.chID = guid
              bfDB_TableTrigger.chTableID = mchCurrentTableID
              bfDB_TableTrigger.chEvent = replace(mchSecondToken,'"',"")
              bfDB_TableTrigger.chProcedureName = replace(entry(5,chCurrentLine," "),'"',"")
              .
          if replace(entry(3,chCurrentLine," "),'"',"") = "OVERRIDE"
          then bfDB_TableTrigger.lgOverride = true.
          else bfDB_TableTrigger.lgOverride = false.
          if replace(entry(7,chCurrentLine," "),'"',"") = "?"
          then bfDB_TableTrigger.inCRC = ?.
          else bfDB_TableTrigger.inCRC = integer(replace(entry(7,chCurrentLine," "),'"',"")).
        end.
        when "VALMSG-SA" then mchValMsgSA = QuotedExp(chCurrentLine).
        otherwise do:
          obReport:WriteMessage ( substitute("BuildSchemaDF WARNING: Unexpected token '&1' in TableAdd at line &2 processing DB &3", mchFirstToken, inLineNo, chCurrentDBName )).
          inTotalExceptions = inTotalExceptions + 1.
        end.
      end case.
    end /* repeat */. 
    if mchTableName > ""  
    then do for bfDB_Table on error undo, throw:
      create bfDB_Table.
      assign
          bfDB_Table.chID = mchCurrentTableID
          bfDB_Table.chDBID = chCurrentDBID
          bfDB_Table.chTableName = mchTableName
          bfDB_Table.chArea = mchTableArea
          bfDB_Table.chDumpName = mchTableDumpName
          bfDB_Table.chDescription = mchTableDescription
          bfDB_Table.chTableLabel = mchLabel
          bfDB_Table.chTableLabelSA = mchLabelSA          
          bfDB_Table.lgFrozen        = mlgFrozen
          bfDB_Table.lgHidden        = mlgHidden
          bfDB_Table.chCategory      = mchCategory
          bfDB_Table.chValMsgSA = mchValMsgSA
          bfDB_Table.chForName = mchForeignName
          .
      /* Create a dummy column for RECID joins */
      do for bfDB_Column:
        create bfDB_Column.
        assign
            bfDB_Column.chID   = guid
            bfDB_Column.chTableID    = bfDB_Table.chID
            bfDB_Column.chColumnName = "RECID"
            bfDB_Column.chFormat = "99999999"
            bfDB_Column.inExtent = 0
            bfDB_Column.inOrder = -1
            bfDB_Column.chCanRead = "*"
            bfDB_Column.chCanWrite = "*"
            bfDB_Column.chDataType   = "INTEGER"
            bfDB_Column.lgMandatory = true
            bfDB_Column.inColumnPhysPos = -1
            .
        put unformatted ": ":U mchTableName " ":U bfDB_Column.chID skip.  /* 2nd field was recid, but not used */
      end.
      catch eobSysError as Progress.Lang.SysError :
        log-manager:write-message (substitute("BuildSchemaDF: EXCEPTION: ProcessTableAdd: Table = &1, Error = &2 processing DB &3", mchTableName, eobSysError:getMessage(1), chCurrentDBName ), "SYSERROR").
        if eobSysError:NumMessages > 1
        then do minWhich = 2 to eobSysError:NumMessages:
          log-manager:write-message (substitute("BuildSchemaDF: EXCEPTION: ProcessTableAdd (cont.): &1", eobSysError:getMessage(minWhich)), "SYSERROR").
        end.
        delete object eobSysError no-error.
        undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Aborting." ).             
      end catch.
    end /* do */. 
  end method.
  
  method private void ProcessColumnAdd():
    define variable mchFirstToken  as character no-undo.    
    define variable mchSecondToken as character no-undo.    
    define variable mchThirdToken as character no-undo.  
    define variable mchFifthToken as character no-undo.  
    
    define variable mchColumnName as character no-undo.
    define variable mchTableName  as character no-undo.
    define variable mchDataType as character no-undo.
    define variable mlgColumnCase as logical no-undo initial no.
    define variable mchFormat as character no-undo.
    define variable mchHelp as character no-undo initial "".
    define variable mchInitial as character no-undo.
    define variable mchLabel as character no-undo.
    define variable mlgMandatory as logical no-undo initial no.
    define variable minWidth as integer no-undo.
    define variable minOrder as integer no-undo.
    define variable minPosition as integer no-undo.
    define variable mchColumnDescription as character no-undo.
    define variable mchColumnLabel as character no-undo.
    define variable minExtent as integer no-undo initial 0.
    define variable mchValidationExp as character no-undo.
    define variable mchValidationMsg as character no-undo.
    define variable minDecimals as integer no-undo.
    define variable mchLOBArea as character no-undo.
    define variable minLOBSize as integer no-undo.
    define variable minLOBBytes as integer no-undo.
    define variable mchViewAs as character no-undo.
    define variable mchInitialSA as character no-undo.
    define variable mchHelpSA as character no-undo.
    define variable mchFormatSA as character no-undo.
    define variable mchColLabelSA as character no-undo.
    define variable mchValidationMsgSA as character no-undo.
    define variable mchCharSet as character no-undo.
    define variable mchCollation as character no-undo.
    define variable minAttributes1 as integer no-undo.
    define variable mchLabelSA as character no-undo.
    define variable minWhich as integer no-undo.
    
    define buffer bfDB_Table for DB_Table.
    define buffer bfDB_Column for DB_Column.
    
    assign
        inColumnTotal = inColumnTotal + 1
        mchThirdToken = entry(3,chCurrentLine," ")
        mchColumnName = replace(mchThirdToken,'"',"")  
        mchFifthToken = entry(5,chCurrentLine," ")
        mchTableName = replace(mchFifthToken,'"',"")  
        mchDataType = entry(7,chCurrentLine," ")
        .
    PROCESS-LOOP:
    repeat:
      import stream stSchemaDF unformatted chCurrentLine.
      chCurrentLine = trim(chCurrentLine).
      inLineNo = inLineNo + 1.
      if chCurrentLine = "" or chCurrentLine = "." then leave PROCESS-LOOP.
      mchFirstToken = entry(1,chCurrentLine," ").
      if num-entries(chCurrentLine," ") > 1 
      then mchSecondToken = entry(2,chCurrentLine," ").
      else mchSecondToken = "".
      case mchFirstToken:
        when "CASE-SENSITIVE" then mlgColumnCase = yes.
        when "CLOB-CODEPAGE" then mchCharset = QuotedExp(chCurrentLine).
        when "CLOB-COLLATION" then mchCollation = QuotedExp(chCurrentLine).        
        when "DECIMALS" then minAttributes1 = integer( mchSecondToken ).        
        when "COLUMN-LABEL" then mchColumnLabel = QuotedExp(chCurrentLine).
        when "COLUMN-LABEL-SA" then mchColLabelSA = QuotedExp(chCurrentLine).
        when "DECIMALS" then minDecimals = integer( mchSecondToken ).
        when "DESCRIPTION" then mchColumnDescription = QuotedExp(chCurrentLine).
        when "EXTENT" then minExtent = integer(mchSecondToken).
        when "FORMAT" then mchFormat = mchSecondToken.
        when "FORMAT-SA" then mchFormatSA = mchSecondToken.
        when "HELP" then mchHelp = QuotedExp(chCurrentLine).
        when "HELP-SA" then mchHelpSA = QuotedExp(chCurrentLine).
        when "INITIAL" then mchInitial = mchSecondToken.
        when "INITIAL-SA" then mchInitialSA = mchSecondToken.
        when "LABEL" then mchLabel = QuotedExp(chCurrentLine).
        when "LABEL-SA" then mchLabelSA = QuotedExp(chCurrentLine).
        when "LENGTH" then minDecimals = integer( mchSecondToken ).
        when "LOB-AREA" then mchLOBArea = mchSecondToken.
        when "LOB-BYTES"
          then do:
            if mchSecondToken = replace(mchSecondToken,"M","") 
            then minLOBBytes = integer(mchSecondToken).
            else minLOBBytes = integer(replace(mchSecondToken,"M","")) * 1024 * 1024.
          end.
        when "LOB-SIZE"
          then do:
            if mchSecondToken = replace(mchSecondToken,"M","") 
            then minLOBSize = integer(mchSecondToken).
            else minLOBSize = integer(replace(mchSecondToken,"M","")) * 1024 * 1024.
          end.
        when "MANDATORY" then assign mlgMandatory = yes.
        when "MAX-WIDTH" then minWidth = integer(mchSecondToken).
        when "ORDER" then minOrder = integer(mchSecondToken).
        when "POSITION" then minPosition = integer(mchSecondToken).
        when "SQL-WIDTH" then minWidth = integer(mchSecondToken).
        when "VALEXP" then mchValidationExp = mchSecondToken.
        when "VALMSG" then mchValidationMsg = mchSecondToken.
        when "VALMSG-SA" then mchValidationMsgSA = mchSecondToken.
        when "VIEW-AS" then mchViewAs = QuotedExp(chCurrentLine).
        otherwise do:
          obReport:WriteMessage ( substitute("BuildSchemaDF WARNING: Unexpected token '&1' in ColumnAdd at line &2 processing DB &3", mchFirstToken, inLineNo, chCurrentDBName ) ).
          inTotalExceptions = inTotalExceptions + 1.
        end.
      end case.
    end /* repeat */. 
    if mchColumnName > ""  
    then do for bfDB_Table, bfDB_Column on error undo, throw:
      find bfDB_Table no-lock
          where bfDB_Table.chDBID = chCurrentDBID 
          and   bfDB_Table.chTableName = mchTableName
          no-error.
      if not available(bfDB_Table)
      then do:
        obReport:WriteMessage ( substitute("BuildSchemaDF ERROR: Encountered Column &1 of Table `&2', Table not yet in bfDB_Table at line &3 processing DB &4", mchColumnName, mchTableName, inLineNo, chCurrentDBName )).
        inTotalExceptions = inTotalExceptions + 1.
        undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Aborting." ).        
      end.
      create bfDB_Column.
      assign
          bfDB_Column.chID   = guid
          bfDB_Column.chTableID    = bfDB_Table.chID
          bfDB_Column.chColumnName = mchColumnName
          bfDB_Column.chDataType   = mchDataType
          bfDB_Column.lgColumnCase = mlgColumnCase
          bfDB_Column.chFormat    = mchFormat
          bfDB_Column.chFormatSA  = mchFormatSA    
          bfDB_Column.chHelp      = mchHelp
          bfDB_Column.chHelpSA    = mchHelpSA      
          bfDB_Column.chInitial   = mchInitial
          bfDB_Column.chInitialSA = mchInitialSA    
          bfDB_Column.chLabel     = mchLabel 
          bfDB_Column.chLabelSA   = mchLabelSA  
          bfDB_Column.lgMandatory = mlgMandatory
          bfDB_Column.inWidth     = minWidth    
          bfDB_Column.inOrder     = minOrder    
          bfDB_Column.inColumnPhysPos = minPosition
          bfDB_Column.chDescription = mchColumnDescription 
          bfDB_Column.chColumnLabel = mchColumnLabel
          bfDB_Column.chColLabelSA = mchColLabelSA
          bfDB_Column.inExtent      = minExtent
          bfDB_Column.chValidationExp = mchValidationExp
          bfDB_Column.chValidationMsg = mchValidationMsg
          bfDB_Column.chValidationMsgSA = mchValidationMsgSA
          bfDB_Column.inDecimals    = minDecimals
          bfDB_Column.chLOBArea     = mchLOBArea
          bfDB_Column.inLOBBytes    = minLOBBytes
          bfDB_Column.inLOBSize     = minLOBSize
          bfDB_Column.chViewAs      = mchViewAs
          .
       put unformatted 
           mchColumnName 
           " ":U bfDB_Column.chID       /* 2nd field was recid, but not used */
           " ":U caps(mchDataType) 
           " ":U minExtent 
           skip.
      
      catch eobSysError as Progress.Lang.SysError :
        define variable inWhich as integer no-undo.
        log-manager:write-message (substitute("BuildSchemaDF: EXCEPTION: ProcessColumnAdd: Table = &1; Column = &2; Error = &3 processing DB &4", mchTableName, mchColumnName, eobSysError:getMessage(1), chCurrentDBName ), "SYSERROR").
        if eobSysError:NumMessages > 1
        then do minWhich = 2 to eobSysError:NumMessages:
          log-manager:write-message (substitute("BuildSchemaDF: EXCEPTION: ProcessColumnAdd (cont.): &1", eobSysError:getMessage(minWhich)), "SYSERROR").
        end.
        delete object eobSysError no-error.
        undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Aborting." ).             
      end catch.
    end /* do */. 
  end.
  
  method private void ProcessIndexAdd():
    define variable mchFirstToken  as character no-undo.    
    define variable mchSecondToken as character no-undo.    
    define variable mchThirdToken  as character no-undo.  
    define variable mchFourthToken as character no-undo.  
    define variable mchFifthToken  as character no-undo. 
    
    define variable mchIndexName as character no-undo.
    define variable mchTableName as character no-undo.  
    define variable mchArea as character no-undo.
    define variable mchColumnName as character no-undo.
    define variable mlgAscending as logical no-undo initial true.
    define variable mlgUnique as logical no-undo.
    define variable mlgPrimary as logical no-undo.
    define variable minWord as integer no-undo initial ?.
    define variable mchDB_IndexColumn as character no-undo.
    define variable mlgFirstColumn as logical no-undo initial true.
    define variable mchCurrentIndexID as character no-undo case-sensitive.
    define variable mchDescription as character no-undo.
    define variable minWhich as integer no-undo.
    
    define buffer bfDB_Table for DB_Table.
    define buffer bfDB_Column for DB_Column.
    define buffer bfDB_Index for DB_Index.
    define buffer bfDB_IndexColumn for DB_IndexColumn.
    
    assign
        inIndexTotal = inIndexTotal + 1
        mchThirdToken = entry(3,chCurrentLine," ")
        mchIndexName = replace(mchThirdToken,'"',"")  
        mchFifthToken = entry(5,chCurrentLine," ")
        mchTableName = replace(mchFifthToken,'"',"")
        .  
    PROCESS-LOOP:
    repeat:
      import stream stSchemaDF unformatted chCurrentLine.
      inLineNo = inLineNo + 1.
      chCurrentLine = trim(chCurrentLine).
      if chCurrentLine = "" or chCurrentLine = "." then leave PROCESS-LOOP.
      mchFirstToken = entry(1,chCurrentLine," ").
      if num-entries(chCurrentLine," ") > 1 
      then mchSecondToken = entry(2,chCurrentLine," ").
      else mchSecondToken = "".
      case mchFirstToken:
        when "AREA" then mchArea = replace(mchSecondToken,'"',"").  
        when "PRIMARY" then mlgPrimary = yes.
        when "UNIQUE" then mlgUnique = yes.   
        when "DESCRIPTION" then mchDescription = QuotedExp(chCurrentLine).   
        when "INDEX-FIELD" 
          then do for bfDB_Table:
            mchColumnName = replace(mchSecondToken,'"',"").
            if mchColumnName > ""  
            then do:
              find bfDB_Table exclusive-lock
                  where bfDB_Table.chDBID = chCurrentDBID 
                  and   bfDB_Table.chTableName = mchTableName
                  no-error.
              if not available(bfDB_Table)
              then do:
                obReport:WriteMessage ( substitute("BuildSchemaDF ERROR: Encountered Index '(&1)' of Table `&2', Table not yet in bfDB_Table at line &3 processing DB &4", mchColumnName, mchTableName, inLineNo, chCurrentDBName )).
                inTotalExceptions = inTotalExceptions + 1.
                undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Aborting." ).        
              end.
              if mlgFirstColumn
              then do for bfDB_Index on error undo, throw:
                create bfDB_Index.
                assign
                    bfDB_Index.chID = guid
                    bfDB_Index.chTableID  = bfDB_Table.chID
                    bfDB_Index.chIndexName = mchIndexName
                    bfDB_Index.lgUnique = mlgUnique
                    bfDB_Index.chArea = mchArea
                    bfDB_Index.chDescription = mchDescription
                    bfDB_Index.inWordIndex = minWord
                    mchCurrentIndexID = bfDB_Index.chID
                    mlgFirstColumn = false
                    .
                if mlgPrimary then bfDB_Table.chPrimeIndexID = bfDB_Index.chID.
                catch eobSysError as Progress.Lang.SysError :
                  log-manager:write-message ( substitute("BuildSchemaDF: EXCEPTION: ProcessIndexAdd: Table = &1, Index = &2, Error = &3 processing DB &4", mchTableName, mchIndexName, eobSysError:getMessage(1), chCurrentDBName ), "SYSERROR").
                  if eobSysError:NumMessages > 1
                  then do minWhich = 2 to eobSysError:NumMessages:
                    log-manager:write-message ( substitute("BuildSchemaDF: EXCEPTION: ProcessIndexAdd (cont.): &1", eobSysError:getMessage(minWhich)), "SYSERROR").
                  end.
                  delete object eobSysError no-error.
                  undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Aborting." ).             
                end catch.                
              end. /* FirstColumn */
              do for bfDB_Index, bfDB_IndexColumn, bfDB_Column on error undo, throw:
                mchDB_IndexColumn = replace(mchSecondToken,'"',"").
                assign mlgAscending = no when entry(3,chCurrentLine," ") <> "ASCENDING".
                find bfDB_Index exclusive-lock where bfDB_Index.chID = mchCurrentIndexID no-error.
                if not available( bfDB_Index )
                then do:
                  obReport:WriteMessage ( substitute("BuildSchemaDF ERROR: Encountered in Index &1 of Table &2, Index not yet in bfDB_Index at line &3 processing DB &4", mchIndexName, mchTableName, inLineNo, chCurrentDBName )).
                  inTotalExceptions = inTotalExceptions + 1.
                  undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Aborting." ).
                end.                       
                bfDB_Index.inNumComp = bfDB_Index.inNumComp + 1.
                
                find bfDB_Column exclusive-lock 
                    where bfDB_Column.chColumnName = mchDB_IndexColumn
                    and   bfDB_Column.chTableID = bfDB_Table.chID
                    no-error.
                if not available( bfDB_Column )
                then do:
                  obReport:WriteMessage ( substitute("BuildSchemaDF ERROR: Encountered in Index '&1' of Table `&2', Column not yet in bfDB_Column at line &3 processing DB &4", mchColumnName, mchTableName, inLineNo, chCurrentDBName )).
                  inTotalExceptions = inTotalExceptions + 1.
                  undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Aborting." ).
                end.                                      
                create bfDB_IndexColumn.
                assign
                    bfDB_IndexColumn.chID = guid
                    bfDB_IndexColumn.chIndexID = bfDB_Index.chID
                    bfDB_IndexColumn.inIndexSeq = bfDB_Index.inNumComp
                    bfDB_IndexColumn.chColumnID = bfDB_Column.chID
                    bfDB_IndexColumn.lgIsAscending = mlgAscending
                    . 
                catch eobSysError as Progress.Lang.SysError :
                  log-manager:write-message ( substitute("BuildSchemaDF: EXCEPTION: ProcessIndexAdd-Column: DB = &1, Table = &2, Index = &3, Column = &4, Error = &5, line &6", chCurrentDBName, mchTableName, mchIndexName, mchDB_IndexColumn, eobSysError:getMessage(1), string (inLineNo)), "SYSERROR").
                  if eobSysError:NumMessages > 1
                  then do minWhich = 2 to eobSysError:NumMessages:
                    log-manager:write-message ( substitute("BuildSchemaDF: EXCEPTION: ProcessIndexAdd-Column (cont.): &1", eobSysError:getMessage(minWhich)), "SYSERROR").
                  end.
                  delete object eobSysError no-error.
                  undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Aborting." ).             
                end catch.
              end. /* for bfDB_Index */         
            end. /* > "" */
          end. /* when INDEX-Column */
        when "WORD" then minWord = 1.
        otherwise do:
          obReport:WriteMessage ( substitute("BuildSchemaDF WARNING: Unexpected token '&1' in IndexAdd at line &2 processing DB &3", mchFirstToken, inLineNo, chCurrentDBName )).
          inTotalExceptions = inTotalExceptions + 1.
        end.
      end case.
    end /* repeat */. 
  end method. /* IndexAdd */    
  
  method private void ProcessSequenceAdd():
    define variable mchFirstToken as character no-undo.
    define variable mchSecondToken as character no-undo.
    define variable mchThirdToken as character no-undo.
    define variable mchSequenceName as character no-undo.
    define variable minInitial as int64 no-undo.
    define variable minIncrement as int64 no-undo.
    define variable mchCycle as character no-undo.
    define variable mlgCycle as logical no-undo.
    define variable minMinVal as int64 no-undo.
    define variable minMaxVal as int64 no-undo.
    
    define buffer bfDB_Sequence for DB_Sequence.
    
    mchThirdToken = entry(3,chCurrentLine," ").
    mchSequenceName = replace(mchThirdToken,'"',"").  
    PROCESS-LOOP:
    repeat:
      import stream stSchemaDF unformatted chCurrentLine.
      inLineNo = inLineNo + 1.
      chCurrentLine = trim(chCurrentLine).
      if chCurrentLine = "" or chCurrentLine = "." then leave PROCESS-LOOP.
      mchFirstToken = entry(1,chCurrentLine," ").
      if num-entries(chCurrentLine," ") > 1 
      then mchSecondToken = entry(2,chCurrentLine," ").
      else mchSecondToken = "".
      case mchFirstToken:
        when "INITIAL" then minInitial = int64(mchSecondToken).
        when "INCREMENT" then minIncrement = int64(mchSecondToken).
        when "CYCLE-ON-LIMIT" then mchCycle = mchSecondToken.   
        when "MIN-VAL" then minMinVal = int64(mchSecondToken).   
        when "MAX-VAL" then minMaxVal = int64(mchSecondToken).
        otherwise do:
          obReport:WriteMessage ( substitute("BuildSchemaDF WARNING: Unexpected token '&1' in SequenceAdd at line &2 processing DB &3", mchFirstToken, inLineNo, chCurrentDBName )).
          inTotalExceptions = inTotalExceptions + 1.
        end.
      end case.
    end. /* PROCESS-LOOP */
    if mchCycle = "yes" 
    then mlgCycle = yes.
    else mlgCycle = no.
    if mchSequenceName > ""
    then do for bfDB_Sequence on error undo, throw:
      create bfDB_Sequence.
      assign
          bfDB_Sequence.chID   = guid
          bfDB_Sequence.chDBID    = chCurrentDBID
          bfDB_Sequence.chSequenceName = mchSequenceName
          bfDB_Sequence.inSequenceNum = ?
          bfDB_Sequence.inInitial = minInitial
          bfDB_Sequence.inIncrement = minIncrement
          bfDB_Sequence.inMinimum = minMinVal
          bfDB_Sequence.inMaximum = minMaxVal
          bfDB_Sequence.lgCycle = mlgCycle
          .
    end. /* do for bfDB_Sequence */
  end method.
  
  method private void ProcessDrop():
    obReport:WriteMessage ( substitute("BuildSchemaDF ERROR: Encountered DROP token at line &1 processing DB &2", inLineNo, chCurrentDBName )).
    inTotalExceptions = inTotalExceptions + 1.
    undo, throw new Progress.Lang.AppError( "BuildSchemaDF: Aborting.  No support for incremental .df yet" ).      
  end method.
  
   method private character QuotedExp (
      input ipchLine as character
      ):
    define variable mchResult as character no-undo.
    define variable minPos as integer no-undo.
    
    mchResult = left-trim(ipchLine).
    minPos = index(mchResult," ").
    if minPos = 0 then return "".                                          /* initial line has keyword, but nothing following */
    mchResult = left-trim(substring(mchResult, minPos)," ").               /* get rid of keyword and space */
    if substring( mchResult, 1, 1) <> '"' then return mchResult.           /* not quoted */
    mchResult = substring(mchResult, 2).                                   /* drop leading quote */ 
    mchResult = replace(mchResult, '""', chr(1) ).                         /* mask double quotes */
    minPos = index(mchResult, '"').                                        /* look for quote */
    repeat while minPos = 0:                                               /* no closing quote on current result */
      import stream stSchemaDF unformatted chCurrentLine.                  /* get another line */
      inLineNo = inLineNo + 1.                                             /* increment count */
      mchResult = mchResult + " " + replace(chCurrentLine, '""', chr(1) ). /* add to result and mask double quotes */
      minPos = index(mchResult, '"').                                      /* look for quote */
    end.                                                                   /* end loop */
    substring( mchResult, minPos, 1 ) = "".                                /* get rid of trailing quote */
    mchResult = replace(mchResult, chr(1), '""' ).                         /* put back double quotes */
    return mchResult.
   end method.
*/   
end class.