/*------------------------------------------------------------------------
   File        : DumpOneSchema
   Purpose     : 
   Syntax      : 
   Description : Dump schema of one database for use by Proparse.
               : Does not include metaschema.
   Author(s)   : Administrator
   Created     : Mon Mar 05 16:01:05 PST 2012
   Notes       : Assumes DICTDB alias has been set to desired DB
               : Output is append to allow for putting multiple schemas 
               : in one file. 
 ----------------------------------------------------------------------*/

using Progress.Lang.*.

routine-level on error undo, throw.

class com.cintegrity.Proparse.DumpOneSchema: 
  define private stream stSchemas.
		
  constructor public DumpOneSchema ( ):
 
  end constructor.

  method public void DoDump( ipchOutputFile as character , ipinWhichDB as integer ):
    output stream stSchemas to value(ipchOutputFile) append.
    put stream stSchemas unformatted ":: ":U ldbname(ipinWhichDB) " ":U ipinWhichDB skip.    
    
    for each DICTDB._file where DICTDB._file._tbl-type = "T":U no-lock by DICTDB._file._file-name:
      put stream stSchemas unformatted ": ":U DICTDB._file._file-name " ":U recid(DICTDB._file) skip.
      for each DICTDB._field of DICTDB._file no-lock by DICTDB._field._field-rpos:
        put stream stSchemas unformatted
            DICTDB._field._field-name 
            " ":U recid(DICTDB._field) 
            " ":U caps(DICTDB._field._data-type) 
            " ":U DICTDB._field._extent 
          skip.
      end.
    end.    

    output stream stSchemas close.

  end.
  
  method public void DumpMetaSchema(  input ipchDumpFileName as character ):
    
    output stream stSchemas to value ( ipchDumpFileName ) append.
    put stream stSchemas unformatted ":: dictdb 0":U skip.
    
    for each DICTDB._file where _file._tbl-type <> "T":U no-lock by _file._file-name:
      put stream stSchemas unformatted ": ":U _file._file-name " ":U recid(_file) skip.
      for each DICTDB._field of _file no-lock by _field._field-rpos:
        put stream stSchemas unformatted 
           _field._field-name 
           " ":U recid(_field) 
           " ":U caps(_field._data-type) 
           " ":U _field._extent 
           skip.
      end.
    end.

    output stream stSchemas close.
    
  end.

end class.