/*------------------------------------------------------------------------
    File        : SetEnvironment
    Purpose     : 
    Syntax      : 
    Description : Set up context variables for use by Proparse
    Author(s)   : Thomas Mercer-Hursh
    Created     : Mon Mar 05 14:53:16 PST 2012
    Notes       : 
  ----------------------------------------------------------------------*/

using Progress.Lang.*.
using com.joanju.proparse.Environment from assembly.
using org.prorefactor.refactor.RefactorSession from assembly.

routine-level on error undo, throw.

class com.cintegrity.Proparse.SetEnvironment: 

  define variable obProparseEnvironment as class Environment no-undo.
  define variable obProparseSession as class RefactorSession no-undo.
    		
  constructor public SetEnvironment (  ):

  end constructor.
  
  destructor public SetEnvironment (  ):
    if valid-object(obProparseEnvironment) then delete object obProparseEnvironment.
    if valid-object(obProparseSession) then delete object obProparseSession.
  end destructor.
  
  method public void Initialize ( ):
    obProparseEnvironment = Environment:instance().
    obProparseEnvironment:configSet("batch-mode", string(session:batch-mode, "true/false")).
    obProparseEnvironment:configSet("opsys", opsys).
    obProparseEnvironment:configSet("propath", propath).
    obProparseEnvironment:configSet("proversion", proversion).
    obProparseEnvironment:configSet("window-system", session:window-system).
    
    obProparseSession = RefactorSession:getInstance().
    obProparseSession:setContextDirName(session:temp-directory + "/").    
  end method.
  
  method public void SetShowDirectives(
      iplgShowProparseDirectives as logical
      ):
    if iplgShowProparseDirectives 
    then obProparseEnvironment:configSet("show-proparse-directives":U, "true":U).
    else obProparseEnvironment:configSet("show-proparse-directives":U, "false":U).
  end method.

end class.